#!/usr/bin/perl
use Env '$HOME';
local $/ = "BEGIN:VEVENT";
my $calendarfile = $ARGV[0];
my $attachedfile = $ARGV[1];

my $sw_vers = `sw_vers -productVersion`;
my $isTigerFlag = ($sw_vers =~ /^10.4.*/);
my $isLeopardFlag = ($sw_vers =~ /^10.5.*/);

if ($isTigerFlag) {

# Tiger Fix - Sometimes the $HOME environment variable is not set when script invoked by AppleScript invoked by iCal daemon.  Problem seemed to affect 10.4.0 but not 10.4.1.
if (length($HOME)==0) {
    $calendarfile =~ /^\/Users\/(.+?)\/Library\/Calendars\/iRecordMusic.ics$/;
    $HOME = "/Users/$1/";
}

# Tiger Fix - On Tiger, the calendar files have moved.  We search for the IRM calendar file manually.
# UID of calendar does not match directory name.  Once found, replace $calendarfile with real location.
if ( -e "$HOME/Library/Application Support/iCal/Sources" ) {
    my $res = `find "$HOME/Library/Application Support/iCal/Sources/" -name Info.plist`;
    my @plists = split /\n/, $res;

    my $found = 0;
    foreach my $plistpath (@plists) {
	if (open(my $pfh, $plistpath)) {
	    while (my $line = <$pfh>) {
		if ($line =~ /<key>Title<\/key>\s*<string>iRecordMusic<\/string>/) {
		    $found = 1;
		    $plistpath =~ s/Info.plist/corestorage.ics/;
		    $calendarfile = $plistpath;
		}
	    }
	} 
	last if ($found == 1);
    }
    exit if ($found == 0);
}

}

open(my $fh, $calendarfile) or exit;

while (my $line = <$fh>) {
    $found = 0;
    $line =~ s/\s//g;
    if ($isLeopardFlag) {
    if ($line =~ /ATTACH:file:\/\/.*\/(.+?\.scpt)/) {
        if ($1 eq $attachedfile) {
		$found = 1;
	}
    }
   } else {
	if ($line =~ /ATTACH;VALUE=URI:.*\/(.+?\.app)/) {
        if ($1 eq $attachedfile) {
		$found = 1;
	}
    }
    }
	if ($found == 1) {
            if ($line =~ /DTSTART;TZID=(.*?):(\d+)T(\d+)/) {
                print $2," ",$3," ",$1,"\n";
                last;
            }
        }

}
close($fh);
